hdu 3038 日了狗的并查集

TT and FF are … friends. Uh… very very good friends -__-b

FF is a bad boy, he is always wooing TT to play the following game with him. This is a very humdrum game. To begin with, TT should write down a sequence of integers-_-!!(bored).

Then, FF can choose a continuous subsequence from it(for example the subsequence from the third to the fifth integer inclusively). After that, FF will ask TT what the sum of the subsequence he chose is. The next, TT will answer FF’s question. Then, FF can redo this process. In the end, FF must work out the entire sequence of integers.

Boring~~Boring~~a very very boring game!!! TT doesn’t want to play with FF at all. To punish FF, she often tells FF the wrong answers on purpose.

The bad boy is not a fool man. FF detects some answers are incompatible. Of course, these contradictions make it difficult to calculate the sequence.

However, TT is a nice and lovely girl. She doesn’t have the heart to be hard on FF. To save time, she guarantees that the answers are all right if there is no logical mistakes indeed.

What’s more, if FF finds an answer to be wrong, he will ignore it when judging next answers.

But there will be so many questions that poor FF can’t make sure whether the current answer is right or wrong in a moment. So he decides to write a program to help him with this matter. The program will receive a series of questions from FF together with the answers FF has received from TT. The aim of this program is to find how many answers are wrong. Only by ignoring the wrong answers can FF work out the entire sequence of integers. Poor FF has no time to do this job. And now he is asking for your help~(Why asking trouble for himself~~Bad boy)
Input
Line 1: Two integers, N and M (1 <= N <= 200000, 1 <= M <= 40000). Means TT wrote N integers and FF asked her M questions.

Line 2..M+1: Line i+1 contains three integer: Ai, Bi and Si. Means TT answered FF that the sum from Ai to Bi is Si. It’s guaranteed that 0 < Ai <= Bi <= N.

You can assume that any sum of subsequence is fit in 32-bit integer.
Output
A single line with a integer denotes how many answers are wrong.
Sample Input
10 5
1 10 100
7 10 28
1 3 32
4 6 41
6 6 1
Sample Output
1

今天本来就很郁闷 还啃到这道题,不开心。题意是告诉你有多少个数和多少组数据,每组数据包括了从 ai 到 aj 的数字和,然后里面有错的有对的,让大家判断有多少个错的。。。做了几道并查集。。这道真的好奇怪。
作为一枚新手,我肯定一开始是想着怎么合并呢。当然要判断错误,肯定是要有一个数组,存的是每个点到一个共同点的和。无奈找不到共同点。后来发现,他们在并查集的根就是他们的公共点啊。
所以开个sum数组。存的是每个点到根节点的距离。
然后你又会发现,他们的根肯定有一样和不一样的呀。那么,两种情况。一样的,就可以直接判断他们之间的差是不是给的那么数。
如果不一样,那么就合并他们的根节点。刚也说了sum数组存的是每个点到根节点的距离(也是差)。所以每次方向都是向根节点靠拢(这里指向右)。由于嘛,在find函数里面,它是从根到底逐个更新,这个好理解。所以呢,每次更新s的时候都是把s存在sum【树根】咯(也就是右边边界咯),但是嘛,如果要合并两个区间,肯定要舍弃掉的一个树根,简称更新,

#include <string>
#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
const int maxn=200010;
int f[maxn];
int sum[maxn];
int find(int v)
{
    if(v==f[v])
        return v;
    else
    {
        int t=f[v];
        f[v]=find(f[v]);
        sum[v]+=sum[t];
        return f[v];
    }
}
int main()
{
    int n,m;
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        int ans=0;
        for(int i=0;i<=n;i++) {
            f[i]=i;
            sum[i]=0;
        }
        for(int i=0;i<m;i++)
        {
            int a,b,s;
            scanf("%d%d%d",&a,&b,&s);
            a--;
            int t1=find(a);
            int t2=find(b);
            if(t1==t2)
            {
                if(sum[a]-sum[b]!=s)
                    ans++;
            }
            else
            {
                f[t1]=t2;
                sum[t1]=s-sum[a]+sum[b];  //旧结点不再保存旧区间的和而是保存的是t1
            }                             //而是在从旧结点这个点到新区间的树根的值
                                          //由于无法直接求出,只能借助于s-sum[a]+sum[b] 想了好久才想明白
        }
        printf("%d\n", ans);
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
01-21 916
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值